<template>
  <div class="home-page">
    <div class="header">
      <router-link to="/" class="logo"><img src="../../public/logo.png"/></router-link>

      <div class="search-container">
        <input placeholder="Пошук" class="search-input">
        <button class="search-button">Пошук</button>
      </div>

      <div class="buttons-container">
        <button @click="toCatalog" class="catalog">Каталог</button>
        <button @click="toFavorites" class="favorites">Обрані</button>
        <button @click="toCart" class="cart">Кошик</button>
      </div>

      <div>
        <div v-if="getUser" class="buttons-container">
          <span class="name">{{ getUser.displayName }}</span>
          <img :src="getUser.photoURL" class="avatar" />
          <button @click="onLogout">Log out</button>
        </div>
        <div v-else class="buttons-container">
          <button @click="loginWithGoogle()" class="auth">Авторизуватись</button>
        </div>
      </div>
    </div>

    <div class="other">
      <slot></slot>
    </div>

    <div>
      <router-view></router-view>
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";

export default {
  name: "HeaderSlot",

  computed: {
    ...mapGetters('auth', ['getUser']),
  },

  methods: {
    ...mapActions('auth', ['loginWithGoogle', 'logout']),

    onLogout() {
      this.logout();
      this.$router.push('/');
    },

    toCatalog() {
      return this.$router.push('/catalog')
    },

    toFavorites() {
      return this.$router.push('/favorites')
    },

    toCart() {
      return this.$router.push('/cart')
    },
  },
}
</script>

<style lang="css" scoped>
.home-page {
  display: flex;
  flex-direction: column;
  align-items: center;
}

.header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  padding: 20px;
  background-color: #333;
  border-radius: 25px;
  box-shadow: 0 4px 10px rgba(0, 0, 0, .2);
}

.logo img {
  height: 50px;
  margin-left: 20px;
}

.avatar{
  height: 50px;
}

.name{
  color: #cccccc;
}

.search-container {
  display: flex;
  align-items: center;
  padding-left: 160px;
}

.search-input {
  padding: 10px;
  border: 1px solid #555;
  border-radius: 5px;
  margin-right: 10px;
  padding-right: 120px;
}

.search-button {
  padding: 10px;
  background-color: #555;
  color: #fff;
  border: none;
  cursor: pointer;
  border-radius: 5px;
}

.buttons-container {
  display: flex;
  gap: 20px;
  justify-content: center;
}

.buttons-container button {
  padding: 15px;
  background-color: #555;
  color: #fff;
  border: none;
  cursor: pointer;
  border-radius: 5px;
}

.buttons-container button:hover,
.search-button:hover {
  background-color: #777;
}

.catalog {
}

.favorites {
}

.cart {
}

</style>